<?php
/*
Plugin Name: WP SyntaxHighlighter
Plugin URI: http://www.near-mint.com/blog/software/wp-syntaxhighlighter
Description: This plugin is code syntax highlighter based on <a href="http://alexgorbatchev.com/SyntaxHighlighter/">SyntaxHighlighter</a> ver. 3.0.83 and ver. 2.1.382. Supported languages: Bash, C++, CSS, Delphi, Java, JavaScript, Perl, PHP, Python, Ruby, SQL, VB, XML, XHTML and HTML etc.
Version: 1.6
Author: redcocker
Author URI: http://www.near-mint.com/blog/
Text Domain: wp_sh
Domain Path: /languages
*/
/* 
Last modified: 2011/11/2
License: GPL v2(Except "SyntaxHighlighter" libraries)
*/
/*  Copyright 2011 M. Sumitomo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/* 
'WP SyntaxHighlighter' uses SyntaxHighlighter ver. 3.0.83 and ver. 2.1.382 by Alex Gorbatchev. 
SyntaxHighlighter ver. 3.0.83 is licensed under the MIT and LGPL v3
SyntaxHighlighter ver. 2.1.382 is licensed under the LGPL v3.
*/

load_plugin_textdomain('wp_sh', false, dirname(plugin_basename(__FILE__)).'/languages');
$wp_sh_ver = "1.6";
$wp_sh_db_ver = "1.6";
$wp_sh_plugin_url = plugin_dir_url(__FILE__);
$wp_sh_allowed_str = "3";
// Default setting values
$wp_sh_default_class = 'notranslate';
$wp_sh_default_addl_style = '.syntaxhighlighter,
.syntaxhighlighter a,
.syntaxhighlighter div,
.syntaxhighlighter code,
.syntaxhighlighter table,
.syntaxhighlighter table td,
.syntaxhighlighter table tr,
.syntaxhighlighter table tbody,
.syntaxhighlighter table thead,
.syntaxhighlighter table caption,
.syntaxhighlighter textarea {
font-size: 12px !important; /* Set the font size in pixels */
font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important; /* Set the font type */
}
.syntaxhighlighter table caption {
/* For Title(Caption) */
font-size: 14px !important; /* Set the font size in pixels */
font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important; /* Set the font type */
}
.syntaxhighlighter.nogutter td.code .line {
/* Set the left padding space when no-gutter in ver. 3.0 */
padding-left: 3px !important;
}
.syntaxhighlighter {
/* For Chrome/Safari(WebKit) */
/* Hide the superfluous vertical scrollbar in ver. 3.0 */
overflow-y: hidden !important;
padding: 1px !important;
}
.widget-area.syntaxhighlighter a,
.widget-area.syntaxhighlighter div,
.widget-area.syntaxhighlighter code,
.widget-area.syntaxhighlighter table,
.widget-area.syntaxhighlighter table td,
.widget-area.syntaxhighlighter table tr,
.widget-area.syntaxhighlighter table tbody,
.widget-area.syntaxhighlighter table thead,
.widget-area.syntaxhighlighter table caption,
.widget-area.syntaxhighlighter textarea {
/* For Widget */
font-size: 14px !important; /* Set the font size in pixels */
font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important; /* Set the font type */
}
.widget-area table caption {
/* For Widget */
/* For Title(Caption) */
font-size: 10px !important; /* Set the font size in pixels */
font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important; /* Set the font type */
}';
$wp_sh_default_comment_hl_description_before = __("This site supports <a href=\"http://alexgorbatchev.com/SyntaxHighlighter/\">SyntaxHighlighter</a> via <a href=\"http://www.near-mint.com/blog/software/wp-syntaxhighlighter\">WP SyntaxHighlighter</a>. It can highlight your code. <br /><strong>How to highlight your code:</strong> Paste your code in the comment form, select it and then click the language link button below. This will wrap your code in a <pre> tag and format it when submitted.", "wp_sh");
$wp_sh_default_comment_hl_stylesheet = ".comment_highlight {
margin: 0px 0px 0px 0px;
}
.comment_highlight p {
font-size: 12px;
}
.comment_highlight_button {
margin: 0px 0px 0px 0px;
font-size: 10px;
}";

// Get setting values
$wp_sh_setting_opt = get_option('wp_sh_setting_opt');

// Get updated setting values
if (isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true") {
	include_once('get-updated-settings.php');
}

// Create the language list array
function wp_sh_language_array() {
	// Languages for ver. 3.0
	$wp_sh_pre_language3 = get_option('wp_sh_language3');
	if (is_array($wp_sh_pre_language3)) {
		$wp_sh_language3 = $wp_sh_pre_language3;
	}
	$wp_sh_language3 = array(
		"applescript" => array('AppleScript', 'true'),
		"actionscript3" => array('Actionscript3', 'true'),
		"bash" => array('Bash shell', 'true'),
		"coldfusion" => array('ColdFusion', 'true'),
		"c" => array('C', 'true'),
		"cpp" => array('C++', 'true'),
		"csharp" => array('C#', 'true'),
		"css" => array('CSS', 'true'),
		"delphi" => array('Delphi', 'true'),
		"diff" => array('Diff', 'true'),
		"erlang" => array('Erlang', 'true'),
		"groovy" => array('Groovy', 'true'),
		"html" => array('HTML', 'true'),
		"java" => array('Java', 'true'),
		"javafx" => array('JavaFX', 'true'),
		"javascript" => array('JavaScript', 'true'),
		"pascal" => array('Pascal', 'true'),
		"patch" => array('Patch', 'true'),
		"perl" => array('Perl', 'true'),
		"php" => array('PHP', 'true'),
		"text" => array('Plain Text', 'true'),
		"powershell" => array('PowerShell', 'true'),
		"python" => array('Python', 'true'),
		"ruby" => array('Ruby', 'true'),
		"rails" => array('Ruby on Rails', 'true'),
		"sass" => array('Sass', 'true'),
		"scala" => array('Scala', 'true'),
		"scss" => array('Scss', 'true'),
		"shell" => array('Shell', 'true'),
		"sql" => array('SQL', 'true'),
		"vb" => array('Visual Basic', 'true'),
		"vbnet" => array('Visual Basic .NET', 'true'),
		"xhtml" => array('XHTML', 'true'),
		"xml" => array('XML', 'true'),
		"xslt" => array('XSLT', 'true'),
		);
	// Languages for ver. 2.1
	$wp_sh_pre_language2 = get_option('wp_sh_language2');
	if (is_array($wp_sh_pre_language2)) {
		$wp_sh_language2 = $wp_sh_pre_language2;
	}
	$wp_sh_language2 = array(
		"actionscript3" => array('Actionscript3', 'true'),
		"bash" => array('Bash shell', 'true'),
		"coldfusion" => array('ColdFusion', 'true'),
		"c" => array('C', 'true'),
		"cpp" => array('C++', 'true'),
		"csharp" => array('C#', 'true'),
		"css" => array('CSS', 'true'),
		"delphi" => array('Delphi', 'true'),
		"diff" => array('Diff', 'true'),
		"erlang" => array('Erlang', 'true'),
		"groovy" => array('Groovy', 'true'),
		"html" => array('HTML', 'true'),
		"java" => array('Java', 'true'),
		"javafx" => array('JavaFX', 'true'),
		"javascript" => array('JavaScript', 'true'),
		"pascal" => array('Pascal', 'true'),
		"patch" => array('Patch', 'true'),
		"perl" => array('Perl', 'true'),
		"php" => array('PHP', 'true'),
		"text" => array('Plain Text', 'true'),
		"powershell" => array('PowerShell', 'true'),
		"python" => array('Python', 'true'),
		"ruby" => array('Ruby', 'true'),
		"rails" => array('Ruby on Rails', 'true'),
		"scala" => array('Scala', 'true'),
		"shell" => array('Shell', 'true'),
		"sql" => array('SQL', 'true'),
		"vb" => array('Visual Basic', 'true'),
		"vbnet" => array('Visual Basic .NET', 'true'),
		"xhtml" => array('XHTML', 'true'),
		"xml" => array('XML', 'true'),
		"xslt" => array('XSLT', 'true'),
		);
	// Brush files
	$wp_sh_pre_brush_files = get_option('wp_sh_brush_files');
	if (is_array($wp_sh_pre_brush_files)) {
		$wp_sh_brush_files = $wp_sh_pre_brush_files;
	}
	$wp_sh_brush_files = array(
		"AppleScript" => array('shBrushAppleScript.js', 'applescript', '3.0', 'true'),
		"ActionScript3" => array('shBrushAS3.js', 'as3 actionscript3', '2.1', 'true'),
		"Bash" => array('shBrushBash.js', 'bash shell', '2.1', 'true'),
		"ColdFusion" => array('shBrushColdFusion.js', 'cf coldfusion', '2.1', 'true'),
		"C++" => array('shBrushCpp.js', 'cpp c', '1.5', 'true'),
		"C#" => array('shBrushCSharp.js', 'c# c-sharp csharp', '1.5', 'true'),
		"CSS" => array('shBrushCss.js', 'css', '1.5', 'true'),
		"Delphi" => array('shBrushDelphi.js', 'delphi pas pascal', '1.5', 'true'),
		"Diff" => array('shBrushDiff.js', 'diff patch', '2.1', 'true'),
		"Erlang" => array('shBrushErlang.js', 'erl erlang', '2.1', 'true'),
		"Groovy" => array('shBrushGroovy.js', 'groovy', '2.1', 'true'),
		"Java" => array('shBrushJava.js', 'java', '1.5', 'true'),
		"JavaFX" => array('shBrushJavaFX.js', 'jfx javafx', '2.1', 'true'),
		"JavaScript" => array('shBrushJScript.js', 'js jscript javascript', '1.5', 'true'),
		"Perl" => array('shBrushPerl.js', 'perl pl', '2.1', 'true'),
		"PHP" => array('shBrushPhp.js', 'php', '1.5', 'true'),
		"PlainText" => array('shBrushPlain.js', 'plain text', '2.1', 'true'),
		"PowerShell" => array('shBrushPowerShell.js', 'ps powershell', '2.1', 'true'),
		"Python" => array('shBrushPython.js', 'py python', '1.5', 'true'),
		"Ruby" => array('shBrushRuby.js', 'rails ror ruby rb', '1.5', 'true'),
		"Sass" => array('shBrushSass.js', 'sass scss', '3.0', 'true'),
		"Scala" => array('shBrushScala.js', 'scala', '2.1', 'true'),
		"SQL" => array('shBrushSql.js', 'sql', '1.5', 'true'),
		"VisualBasic" => array('shBrushVb.js', 'vb vbnet', '1.5', 'true'),
		"XML" => array('shBrushXml.js', 'xml xhtml xslt html', '1.5', 'true'),
		);
	// Restore in DB
	update_option('wp_sh_language3', $wp_sh_language3);
	update_option('wp_sh_language2', $wp_sh_language2);
	update_option('wp_sh_brush_files', $wp_sh_brush_files);
}

// Create the settings array
function wp_sh_setting_array() {
	global $wp_sh_default_class, $wp_sh_default_addl_style, $wp_sh_default_comment_hl_description_before, $wp_sh_default_comment_hl_stylesheet;
	$wp_sh_setting_opt = array(
		"highlight_home" => 1,
		"highlight_posts" => 1,
		"highlight_categories" => 1,
		"highlight_archives" => 1,
		"highlight_search" => 1,
		"highlight_comment" => 0,
		"highlight_others" => 0,
		"highlight_widgets" => 0,
		"lib_version" => "3.0",
		"theme" => "Default",
		"auto_links" => "true",
		"addl_style_enable" => 0,
		"collapse" => "false",
		"gutter" => "true",
		"first_line" => "1",
		"padding_line" => "false",
		"smart_tabs" => "true",
		"tab_size" => "4",
		"toolbar" => "true",
		"wrap" => "false",
		"legacy" => 0,
		"css" => 0,
		"select_insert" => 1,
		"codebox" => 1,
		"button_window_size" => "100",
		"button_row" => "1",
		"quicktag" => 1,
		"comment_hl_bt_enable" => 0,
		"comment_hl_description_before_enable" => 0,
		"comment_hl_stylesheet_enable" => 0,
		);
	// Store in DB
	add_option('wp_sh_version', '3.0'); // For backward compatibility
	add_option('wp_sh_gutter', 1); // For backward compatibility
	add_option('wp_sh_first_line', '1'); // For backward compatibility
	add_option('wp_sh_setting_opt', $wp_sh_setting_opt);
	add_option('wp_sh_code_title', '');
	add_option('wp_sh_class_name', $wp_sh_default_class);
	add_option('wp_sh_addl_style', $wp_sh_default_addl_style);
	add_option('wp_sh_collapse_lable_text', '');
	add_option('wp_sh_comment_hl_description_before', $wp_sh_default_comment_hl_description_before);
	add_option('wp_sh_comment_hl_stylesheet', $wp_sh_default_comment_hl_stylesheet);
	add_option('wp_sh_updated', 'false');
	add_option('wp_sh_child_plugin');
}

// Check DB version and register settings
add_action('plugins_loaded', 'wp_sh_check_db_ver');

function wp_sh_check_db_ver() {
	global $wp_sh_db_ver, $wp_sh_default_class, $wp_sh_default_addl_style, $wp_sh_setting_opt, $wp_sh_default_comment_hl_description_before, $wp_sh_default_comment_hl_stylesheet;
	$current_checkver_stamp = get_option('wp_sh_checkver_stamp');
	if (!$current_checkver_stamp || version_compare($current_checkver_stamp, $wp_sh_db_ver, "!=")) {
		$updated_count = 0;
		$migration_count = 0;
		// Register languages when new installation, updated from ver 1.2.3 or older
		if (!$current_checkver_stamp || version_compare($current_checkver_stamp, "1.3", "<")) {
			wp_sh_language_array();
			$updated_count = $updated_count + 1;
		}
		// Register settings when new installation, updated from ver 1.5 or older
		if (!is_array($wp_sh_setting_opt)) {
			wp_sh_setting_array();
			$updated_count = $updated_count + 1;
		}
		// Setting data migration when updated from ver.1.5 or older
		if (!$current_checkver_stamp || version_compare($current_checkver_stamp, "1.5", "<=")) {
			if (get_option('wp_sh_theme')) {
				include_once('data-migration.php');
				$migration_count = $updated_count + 1;
				// Delete un-used options before ver.1.5
				include_once('del-old-options.php');
			}
		}
		// If possible, update to current default values
		if (!$current_checkver_stamp || version_compare($current_checkver_stamp, "1.3.9", "<")) {
			// This option is available since ver 1.0 and updated in ver. 1.3.9
			if (get_option('wp_sh_class_name') == '') {
				update_option('wp_sh_class_name', $wp_sh_default_class);
				$updated_count = $updated_count + 1;
			}
		}
		if (version_compare($current_checkver_stamp, "1.3", ">=") && version_compare($current_checkver_stamp, "1.5", "<")) {
			// This option is available since ver. 1.3.5 and updated in ver. 1.5
			if ($wp_sh_setting_opt['addl_style_enable'] == 0) {
				update_option('wp_sh_addl_style', $wp_sh_default_addl_style);
				$updated_count = $updated_count + 1;
			}
		}
		if (version_compare($current_checkver_stamp, "1.5", "==")) {
			// This option is available since ver. 1.5 and updated in ver. 1.5.5
			if ($wp_sh_setting_opt['comment_hl_description_before_enable'] == 0) {
				update_option('wp_sh_comment_hl_description_before', $wp_sh_default_comment_hl_description_before);
				$updated_count = $updated_count + 1;
			}
			if ($wp_sh_setting_opt['comment_hl_stylesheet_enable'] == 0) {
				update_option('wp_sh_comment_hl_stylesheet', $wp_sh_default_comment_hl_stylesheet);
				$updated_count = $updated_count + 1;
			}
		}
		// Add new setting options when updated from ver.1.5.8 or older
		if ($current_checkver_stamp && version_compare($current_checkver_stamp, "1.5.5", "<=")) {
			$wp_sh_setting_opt['quicktag'] = 1;
			update_option('wp_sh_setting_opt', $wp_sh_setting_opt);
			$updated_count = $updated_count + 1;
		}
		update_option('wp_sh_checkver_stamp', $wp_sh_db_ver);
		// Stamp for showing messages
		if ($updated_count != 0 && $migration_count == 0) {
			update_option('wp_sh_updated', 'true');
		} elseif ($migration_count != 0) {
			update_option('wp_sh_updated', 'migration');
		}
	}
}

// Register setting panel and hooks
add_action('admin_menu', 'wp_sh_register_menu_item');

function wp_sh_register_menu_item() {
	global $wp_sh_setting_opt;
	// Register setting panel
	$wp_sh_page_hook = add_options_page('WP SyntaxHighlighter Options', 'WP SyntaxHighlighter', 'manage_options', 'wp-syntaxhighlighter-options', 'wp_sh_options_panel');
	// CSS and scripts for setting panel
	if ($wp_sh_page_hook != null) {
		$wp_sh_page_hook = '-'.$wp_sh_page_hook;
	}
	add_action('admin_print_scripts'.$wp_sh_page_hook, 'wp_sh_load_jscript_for_admin');
	add_action('admin_print_styles'.$wp_sh_page_hook, 'wp_sh_load_style');
	if (isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true") {
		if ($_POST['addl_style_enable'] == 1) {
			add_action('admin_head'.$wp_sh_page_hook, 'wp_sh_load_addl_style');
		}
	} else {
		if ($wp_sh_setting_opt['addl_style_enable'] == 1) {
			add_action('admin_head'.$wp_sh_page_hook, 'wp_sh_load_addl_style');
		}
	}
	// Show messages for admin
	$updated = get_option('wp_sh_updated');
	if (($updated == "true" || $updated == "migration") && !(isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true") && !(isset($_POST['WP_SH_Reset']) && $_POST['wp_sh_reset'] == "true")) {
		add_action('admin_notices', 'wp_sh_admin_updated_notice');
	}
	if ($updated == "migration" && !(isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true") && !(isset($_POST['WP_SH_Reset']) && $_POST['wp_sh_reset'] == "true")) {
		add_action('admin_notices', 'wp_sh_admin_migration_notice');
	}
}

// Script for the setting panel
function wp_sh_load_jscript_for_admin() {
	global $wp_sh_plugin_url;
	wp_enqueue_script('rc_admin_js', $wp_sh_plugin_url.'js/rc-admin-js.js', false, '1.1');
}

// Message for admin when DB table updated
function wp_sh_admin_updated_notice() {
	echo '<div id="message" class="updated"><p>'.__('WP SyntaxHighlighter has successfully created new DB table.<br />If you upgraded to this version, some new setting options may be added.<br />Go to the <a href="options-general.php?page=wp-syntaxhighlighter-options">setting panel</a> and configure WP SyntaxHighlighter now. Once you save your settings, this message will be cleared.', 'wp_sh').'</p></div>';
}

// Message for admin when data migration done
function wp_sh_admin_migration_notice() {
	echo '<div id="message" class="updated"><p>'.__('All setting data has migrated successfully.<br />If you upgraded from ver. 1.3 or older to this version, a part of setting parameters may be reset to the default values.<br />Go to the <a href="options-general.php?page=wp-syntaxhighlighter-options">setting panel</a> and check your setting parameters. Once you save your settings, this message will be cleared.', 'wp_sh').'</p></div>';
}

// Show plugin info in the setting panel footer
function wp_sh_add_admin_footer() {
	$wp_sh_plugin_data = get_plugin_data(__FILE__);
	printf('%1$s by %2$s<br />', $wp_sh_plugin_data['Title'].' '.$wp_sh_plugin_data['Version'], $wp_sh_plugin_data['Author']);
}

// Register link to the setting panel
add_filter( 'plugin_action_links', 'wp_sh_setting_link', 10, 2);

function wp_sh_setting_link($links, $file) {
	static $this_plugin;
	if (!$this_plugin) $this_plugin = plugin_basename(__FILE__);
	if ($file == $this_plugin){
		$settings_link = '<a href="options-general.php?page=wp-syntaxhighlighter-options">'.__('Settings', 'wp_sh').'</a>';
		array_unshift($links, $settings_link);
	}
	return $links;
}

// Load SyntaxHighlighter TinyMCE Buttons
if ($wp_sh_setting_opt['select_insert'] == 1) {
	include_once('sh-tinymce-button-ins/sh-tinymce-button-ins.php');
}
if ($wp_sh_setting_opt['codebox'] == 1) {
	include_once('sh-tinymce-button-box/sh-tinymce-button-box.php');
}

// Allow tab to indent in TinyMCE
if ($wp_sh_setting_opt['select_insert'] == 1 || $wp_sh_setting_opt['codebox'] == 1) {
	add_filter('tiny_mce_before_init', 'wp_sh_shtb_allow_tab');
}

function wp_sh_shtb_allow_tab($initArray) {
	$initArray['plugins'] = preg_replace("|[,]+tabfocus|i", "", $initArray['plugins']);
	return $initArray;
}

// Register tags and attribtes as TinyMCE valid_elements
add_filter('tiny_mce_before_init', 'wp_sh_shtb_mce_valid_elements');

function wp_sh_shtb_mce_valid_elements($init) {
	if (isset($init['extended_valid_elements']) && !empty($init['extended_valid_elements'])) {
		$init['extended_valid_elements'] .= ',' . 'pre[name|class]';
		$init['extended_valid_elements'] .= ',' . 'textarea[name|class|cols|rows]';
	} else {
		$init['extended_valid_elements'] = 'pre[name|class]';
		$init['extended_valid_elements'] .= ',' . 'textarea[name|class|cols|rows]';
	}
	return $init;
}

// Load jQuery for quicktag
if ($wp_sh_setting_opt['quicktag'] == 1) {
	add_action('admin_print_scripts-post.php', 'wp_sh_load_jquery');
	add_action('admin_print_scripts-post-new.php', 'wp_sh_load_jquery');
	add_action('admin_print_scripts-page.php', 'wp_sh_load_jquery');
	add_action('admin_print_scripts-page-new.php', 'wp_sh_load_jquery');
}

function wp_sh_load_jquery() {
	global $wp_sh_plugin_url;
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-core');
}

// Load stylesheet for jQuery ui
if ($wp_sh_setting_opt['quicktag'] == 1) {
	add_action('admin_print_styles-post.php', 'wp_sh_add_quicktag_css');
	add_action('admin_print_styles-post-new.php', 'wp_sh_add_quicktag_css');
	add_action('admin_print_styles-page.phpp', 'wp_sh_add_quicktag_css');
	add_action('admin_print_styles-new.php', 'wp_sh_add_quicktag_css');
}

function wp_sh_add_quicktag_css() {
	global $wp_sh_plugin_url;
	wp_enqueue_style('jquery-ui', $wp_sh_plugin_url.'css/jquery.ui.all.css', false, '1.8.16');
	wp_enqueue_style('jquery-ui-custom', $wp_sh_plugin_url.'css/jquery-ui-1.8.16.custom.css', false, '1.8.16');
}

// Add quicktag to HTML editor
if ($wp_sh_setting_opt['quicktag'] == 1 && (strpos($_SERVER['REQUEST_URI'], 'post.php') ||
	strpos($_SERVER['REQUEST_URI'], 'post-new.php') ||
	strpos($_SERVER['REQUEST_URI'], 'page.php') ||
	strpos($_SERVER['REQUEST_URI'], 'page-new.php'))) {
	add_action('admin_footer', 'wp_sh_add_quicktag');
}

function wp_sh_add_quicktag() {
	global $wp_sh_setting_opt;

	echo "\n<script type=\"text/javascript\">
function SHpreGetAreaRange(obj) {
	var pos = new Object();
	
	if (isIE) {
		obj.focus();
		var range = document.selection.createRange();
		var clone = range.duplicate();
		
		clone.moveToElementText(obj);
		clone.setEndPoint( 'EndToEnd', range );

		pos.start = clone.text.length - range.text.length;
		pos.end   = clone.text.length - range.text.length + range.text.length;
  	}

	else if(window.getSelection()) {
		pos.start = obj.selectionStart;
		pos.end   = obj.selectionEnd;
	}

	return pos;
}
var isIE = (navigator.appName.toLowerCase().indexOf('internet explorer')+1?1:0);
function SHpreSurroundHTML() {
	var target = document.getElementById('content');
	var pos = SHpreGetAreaRange(target);
	var val = target.value;
	var range = val.slice(pos.start, pos.end);
	range = range.replace(/&/g,\"&amp;\");
	range = range.replace(/</g,\"&lt;\").replace(/>/g,\"&gt;\");
    	var beforeNode = val.slice(0, pos.start);
    	var afterNode  = val.slice(pos.end);
	var insertNode;
//	var tag = prompt('Enter language alias name.'+\"\\n\"+'e.g.: c, javascript, php, xhtml etc.', 'php');

	jQuery(\"#shpre_input_lang\").dialog(
	{
		modal: true,
		height: 180,
		width: 250,
		title: '".__("SH pre button", "wp_sh")."',
		resizable: true,
		buttons: {
			\"OK\": function() {
				var tag = jQuery(\"#shpre_lang\").val();
				var checked = jQuery(\"#shpre_gutter\").is(':checked');
				var gut;
				if (checked == true) {
					gut = 'true';
				} else {
					gut = 'false';
				}
				var fsl = '".$wp_sh_setting_opt['first_line']."';
				if (range || pos.start != pos.end) {
					insertNode = '<pre class=\"brush: ' + tag + '; gutter: ' + gut + '; first-line: ' + fsl + '; highlight: []; html-script: false\">' + range + '</pre>';
					target.value = beforeNode + insertNode + afterNode;
				} else if (pos.start == pos.end) {
		insertNode = '<pre class=\"brush: ' + tag + '; gutter: ' + gut + '; first-line: ' + fsl + '; highlight: []; html-script: false\">' + range + '</pre>';
					target.value = beforeNode + insertNode + afterNode;
				}
				jQuery(this).dialog('close');
			},
			\"CANCEL\": function() {
				jQuery(this).dialog('close');
			},
		}
	});
}

function SHpreRegisterQtButton() {
	jQuery('#ed_toolbar').each( function() {
		var button = document.createElement('input');
		button.type = 'button';
		button.value = '".__("SH pre", "wp_sh")."';
		button.onclick = SHpreSurroundHTML;
		button.className = 'ed_button';
		button.title = '".__("For WP SyntaxHighlighter", "wp_sh")."';
		button.id = 'ed_prequicktag';

		jQuery(this).append(button);
	});
}
 
SHpreRegisterQtButton();
</script>\n";
	// Add dropdown menu
	echo "<div id=\"shpre_input_lang\" style=\"display:none; font-size:12px;\">
<div style=\"margin-top:5px;\">".__("Language", "wp_sh")." <select id=\"shpre_lang\" name=\"shpre_lang\">";
	if ($wp_sh_setting_opt['lib_version'] == '3.0') {
		$language_array = get_option('wp_sh_language3');
	} elseif ($wp_sh_setting_opt['lib_version'] == '2.1') {
		$language_array = get_option('wp_sh_language2');
	}
	if (is_array($language_array)) {
		asort($language_array);
		echo "\n";
		foreach ($language_array as $key => $val) {
			if ($val[1] == 'true' || $val[1] =='added') {
				echo '	<option value="'.$key.'">'.$val[0]."</option>\n";
			}
		}
	}
	echo "</select></div>\n";
	echo "<div style=\"margin-top:10px;\">".__("Show Line Number", "wp_sh")." <input type=\"checkbox\" id=\"shpre_gutter\" name=\"shpre_gutter\" value=\"true\" ";
	if ($wp_sh_setting_opt['gutter'] == "true") {
		echo 'checked="checked" ';
	}
	echo " /></div>
</div>\n";
}

// Load additional style sheet
if ($wp_sh_setting_opt['addl_style_enable'] == 1) {
	add_action('wp_head', 'wp_sh_load_addl_style');
}

function wp_sh_load_addl_style() {
	global $wp_sh_ver, $wp_sh_setting_opt;
	if ($wp_sh_setting_opt['addl_style_enable'] == 1 && ((is_home() && $wp_sh_setting_opt['highlight_home'] == 1) || ((is_single() || is_page()) && $wp_sh_setting_opt['highlight_posts'] == 1) || (is_category() && $wp_sh_setting_opt['highlight_categories'] == 1) || (is_archive() && $wp_sh_setting_opt['highlight_archives'] == 1) || (is_search() && $wp_sh_setting_opt['highlight_search'] == 1) || (comments_open() && $wp_sh_setting_opt['highlight_comment'] == 1) || ($wp_sh_setting_opt['highlight_widgets'] == 1 && is_active_widget(false, false, 'wpsyntaxhighlighterwidget', true)) || (!is_home() && !is_single() && !is_page() && !is_category() && !is_archive() && !is_search() && !is_admin() && $wp_sh_setting_opt['highlight_others'] == 1) || is_admin())) {
		echo "\n<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." CSS for code Begin -->\n";
		if (isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true") {
			$wp_sh_addl_style = wp_sh_valid_css(strip_tags(stripslashes($_POST['wp_sh_addl_style'])));
			if ($wp_sh_addl_style == "invalid") {
				$wp_sh_addl_style = "";
			}
			echo "<style type='text/css'>\n".$wp_sh_addl_style."\n</style>\n";
		} else {
			$wp_sh_addl_style = wp_sh_valid_css(strip_tags(get_option('wp_sh_addl_style')));
			if ($wp_sh_addl_style == "invalid") {
				$wp_sh_addl_style = "";
			}
			echo "<style type='text/css'>\n".$wp_sh_addl_style."\n</style>\n";
		}
		echo "<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." CSS for code End -->\n";
	}
}

// Load stylesheet for fullscreen mode
if (version_compare(get_bloginfo('version'), "3.2", ">=")) {
	add_action('admin_print_styles-post.php', 'wp_sh_editor_style');
	add_action('admin_print_styles-post-new.php', 'wp_sh_editor_style');
	add_action('admin_print_styles-page.php', 'wp_sh_editor_style');
	add_action('admin_print_styles-page-new.php', 'wp_sh_editor_style');
}

function wp_sh_editor_style() {
	global $wp_sh_plugin_url;
	wp_enqueue_style('wpsh-editor', $wp_sh_plugin_url.'css/wpsh_fullscreen.css', false, '1.1');
}

// Allow addtional tags and attributes in the comments
if ($wp_sh_setting_opt['highlight_comment'] == 1) {
	add_filter('comments_open', 'wp_sh_allow_tags_in_comments');
	add_filter('pre_comment_approved', 'wp_sh_allow_tags_in_comments');
}

function wp_sh_allow_tags_in_comments($data) {
	global $allowedtags; 
	$allowedtags['pre'] = array(
				'class'=>array());
	return $data;
}

// Escape character strings to HTML entities in the comments
if ($wp_sh_setting_opt['highlight_comment'] == 1) {
	if (has_filter('comment_text', 'make_clickable')) {
		remove_filter('comment_text', 'make_clickable', 9);
	}
	add_filter('pre_comment_content', 'wp_sh_escape_comment');
	add_filter('comment_text', 'wp_sh_escape_comment');
}

function wp_sh_escape_comment($content) {
	global $wp_sh_setting_opt;
	if (comments_open() && $wp_sh_setting_opt['highlight_comment'] == 1) {
		$match_num = preg_match_all('|<pre[^>]*?>.*?</pre>|is', $content, $match);
		if ($match_num != 0 || $match_num != false) {
			for ($i = 0; $i < $match_num; $i++) {
				$code = preg_replace('|<pre[^>]*?>(.*?)</pre>|is', '$1', $match[0][$i]);
				$replaced_code = addslashes(esc_html($code));
				$content = preg_replace('|'.preg_quote($code, '|').'|', $replaced_code, $content);
			}
		}
	}
	return $content;
}

// Remove CDATA tag
add_filter('the_content', 'wp_sh_post_on_print', 1);

function wp_sh_post_on_print($content) {
	$content = preg_replace("|(<script[^>]*?>)<!\[CDATA\[(.*?)\]\]></script>|is", '$1$2</script>', $content);
	return $content;
}

// Load Comment Highlight Button
if ($wp_sh_setting_opt['comment_hl_bt_enable'] == 1 && version_compare(get_bloginfo('version'), "3.0", ">=")) {
	include_once('comment-highlight-button.php');
}

// Load WP SyntaxHighlighter Widget
if ($wp_sh_setting_opt['highlight_widgets'] == 1) {
	include_once('wp-syntaxhighlighter-widget.php');
	add_action('admin_print_scripts-widgets.php', 'wp_sh_load_script_for_widget');
}

// Load script for widget section
function wp_sh_load_script_for_widget() {
	global $wp_sh_plugin_url;
	wp_enqueue_script('rc_textarea_hl_js', $wp_sh_plugin_url.'js/rc-textarea-hl.js', false, '1.0');
}

// Load css for SyntaxHighlighter on the header
add_action('wp_print_styles', 'wp_sh_load_style');

function wp_sh_load_style() {
	global $wp_sh_plugin_url, $wp_sh_setting_opt;
	if ((is_home() && $wp_sh_setting_opt['highlight_home'] == 1) || ((is_single() || is_page()) && $wp_sh_setting_opt['highlight_posts'] == 1) || (is_category() && $wp_sh_setting_opt['highlight_categories'] == 1) || (is_archive() && $wp_sh_setting_opt['highlight_archives'] == 1) || (is_search() && $wp_sh_setting_opt['highlight_search'] == 1) || (comments_open() && $wp_sh_setting_opt['highlight_comment'] == 1) || ($wp_sh_setting_opt['highlight_widgets'] == 1 && is_active_widget(false, false, 'wpsyntaxhighlighterwidget', true)) || (!is_home() && !is_single() && !is_page() && !is_category() && !is_archive() && !is_search() && !is_admin() && $wp_sh_setting_opt['highlight_others'] == 1) || is_admin()) {
		$wp_sh_theme_list['Default'] = array('1', 'shCoreDefault.css', 'shThemeDefault.css');
		$wp_sh_theme_list['Django'] = array('2', 'shCoreDjango.css', 'shThemeDjango.css');
		$wp_sh_theme_list['Eclipse'] = array('3', 'shCoreEclipse.css', 'shThemeEclipse.css');
		$wp_sh_theme_list['Emacs'] = array('4', 'shCoreEmacs.css', 'shThemeEmacs.css');
		$wp_sh_theme_list['FadeToGrey'] = array('5', 'shCoreFadeToGrey.css', 'shThemeFadeToGrey.css');
		$wp_sh_theme_list['MDUltra'] = array('8', 'shCoreMDUltra.css', 'shThemeMDUltra.css');
		$wp_sh_theme_list['Midnight'] = array('6', 'shCoreMidnight.css', 'shThemeMidnight.css');
		$wp_sh_theme_list['RDark'] = array('7', 'shCoreRDark.css', 'shThemeRDark.css');
		$theme = $wp_sh_setting_opt['theme'];
		$wp_sh_lib_ver = $wp_sh_setting_opt['lib_version'];
		if ($wp_sh_lib_ver == "3.0") {
			$lib_dir = 'syntaxhighlighter3';
		} elseif ($wp_sh_lib_ver == "2.1") {
			$lib_dir = 'syntaxhighlighter2';
		}
		if ($wp_sh_setting_opt['css'] == 1) {
			wp_enqueue_style('pre-tag', $wp_sh_plugin_url.'css/pre.css', false, '1.0');
		}
		wp_enqueue_style('core'.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/shCore.css', false, $wp_sh_lib_ver);
		if ($theme == "Randam") {
			if ($wp_sh_lib_ver == "3.0") {
				$theme_no = mt_rand(1, 8);
				foreach ($wp_sh_theme_list as $theme_name => $val) {
					if ($theme_no == $val[0]) {
						wp_enqueue_style('core-'.$theme_name.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/'.$val[1], false, $wp_sh_lib_ver);
						wp_enqueue_style('theme-'.$theme_name.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/'.$val[2], false, $wp_sh_lib_ver);
					}
				}
			}
			if ($wp_sh_lib_ver == "2.1") {
				$theme_no = mt_rand(1, 7);
				foreach ($wp_sh_theme_list as $theme_name => $val) {
					if ($theme_no == $val[0]) {
						wp_enqueue_style('theme-'.$theme_name.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/'.$val[2], false, $wp_sh_lib_ver);
					}
				}
			}
		} else {
			if ($wp_sh_lib_ver == "2.1" && $theme == "MDUltra") {
				wp_enqueue_style('core-'.$theme.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/shThemeDefault.css', false, $wp_sh_lib_ver);
			} else {
				if ($wp_sh_lib_ver == "3.0") {
					wp_enqueue_style('core-'.$theme.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/'.$wp_sh_theme_list[$theme][1], false, $wp_sh_lib_ver);
				}
				wp_enqueue_style('theme-'.$theme.$wp_sh_lib_ver, $wp_sh_plugin_url.$lib_dir.'/styles/'.$wp_sh_theme_list[$theme][2], false, $wp_sh_lib_ver);
			}
		}
		if ($wp_sh_lib_ver == "3.0") {
			do_action('wpsh_css_for_3'); // Action hook for developers
		} elseif ($wp_sh_lib_ver == "2.1") {
			do_action('wpsh_css_for_2'); // Action hook for developers
		}
	}
}

// Load scripts for SyntaxHighlighter on the footer
add_action('plugins_loaded', 'wp_sh_scripts_for_content');

// Run checking for content
function wp_sh_scripts_for_content() {
	add_action('wp_footer', 'wp_sh_check_valid_tag');
}

// When call this by widget method, write out scripts without checking
function wp_sh_scripts_for_widget() {
	add_action('wp_footer', 'wp_sh_load_scripts_on_footer');
}

// Determine whether valid tag is present
function wp_sh_check_valid_tag() {
	global $wp_sh_setting_opt, $post, $wp_query;
	$highlight = 0;
	// Search valid tag
	if ((is_home() && $wp_sh_setting_opt['highlight_home'] == 1) || ((is_single() || is_page()) && $wp_sh_setting_opt['highlight_posts'] == 1) || (is_category() && $wp_sh_setting_opt['highlight_categories'] == 1) || (is_archive() && $wp_sh_setting_opt['highlight_archives'] == 1) || (is_search() && $wp_sh_setting_opt['highlight_search'] == 1) || (!is_home() && !is_single() && !is_page() && !is_category() && !is_archive() && !is_search() && !is_admin() && $wp_sh_setting_opt['highlight_others'] == 1)) {
		foreach ((array)$wp_query->posts as $key => $post_properties) {
			if (preg_match("/<pre[^>]*?brush:[^>]*?>/i", $post_properties->post_content) || preg_match("/<script[^>]*?type=['\"]syntaxhighlighter['\"][^>]*?>/i", $post_properties->post_content)) {
				$highlight = 1;
				break;
			}
			if ($wp_sh_setting_opt['legacy'] == 1 && $highlight == 0) {
				if (preg_match("/<[(pre)(textarea)][^>]*?name=['\"]code['\"][^>]*?>/i", $post_properties->post_content)) {
					$highlight = 1;
					break;
				}
			}
		}
	}
	if (comments_open() && $wp_sh_setting_opt['highlight_comment'] == 1 && $highlight == 0) {
		$comments = get_comments(array('post_id' => $post->ID, 'status' => 'approve'));
		foreach ($comments as $comment) {
			if (preg_match("/<pre[^>]*?brush:[^>]*?>/i", $comment->comment_content) || preg_match("/<script[^>]*?type=['\"]syntaxhighlighter['\"][^>]*?>/i", $comment->comment_content)) {
				$highlight = 1;
				break;
			}
			if ($wp_sh_setting_opt['legacy'] && $highlight == 0) {
				if (preg_match("/<[(pre)(textarea)][^>]*?name=['\"]code['\"][^>]*?>/i", $comment->comment_content)) {
					$highlight = 1;
					break;
				}
			}
		}
	}
	// Write out scripts
	if ($highlight == 1) {
		wp_sh_load_scripts_on_footer();
	} else {
		echo '';
	}
}

// Write out scripts for SyntaxHighlighter on footer
function wp_sh_load_scripts_on_footer() {
	global $wp_sh_ver, $wp_sh_plugin_url, $wp_sh_setting_opt;
	static $count = 0;
	$count++;
	if ($count == 1) {
		// Define values
		$wp_sh_lib_ver = $wp_sh_setting_opt['lib_version'];
		if ($wp_sh_lib_ver == "3.0") {
			$lib_dir = 'syntaxhighlighter3';
		} elseif ($wp_sh_lib_ver == "2.1") {
			$lib_dir = 'syntaxhighlighter2';
		}
		$auto_links = $wp_sh_setting_opt['auto_links'];
		$title = str_replace("'", "&#039;", get_option('wp_sh_code_title'));
		$class_name = get_option('wp_sh_class_name');
		if (strpos($wp_sh_class_name, "\"") || strpos($wp_sh_class_name, "'")) {
			$class_name = "";
		}
		$collapse = $wp_sh_setting_opt['collapse'];
		$first_line = $wp_sh_setting_opt['first_line'];
		if (!preg_match("/^[0-9]+$/", $first_line)) {
			$wp_sh_setting_opt['first_line'] = "1";
		}
		$gutter = $wp_sh_setting_opt['gutter'];
		$padding_line = $wp_sh_setting_opt['padding_line'];
		$smart_tabs = $wp_sh_setting_opt['smart_tabs'];
		$tab_size = $wp_sh_setting_opt['tab_size'];
		if (!preg_match("/^[0-9]+$/", $tab_size)) {
			$wp_sh_setting_opt['tab_size'] = "4";
		}
		$toolbar = $wp_sh_setting_opt['toolbar'];
		$wrap = $wp_sh_setting_opt['wrap'];
		$legacy_enable = $wp_sh_setting_opt['legacy'];
		if ($legacy_enable == 1) {
			$legacy = "dp.SyntaxHighlighter.HighlightAll('code')";
		} else {
			$legacy = "";
		}
		$collapse_lable_text = str_replace("'", "&#039;", get_option('wp_sh_collapse_lable_text'));
		if ($wp_sh_lib_ver == "3.0") {
			if ($collapse_lable_text != "" && $title == "") {
				$collapse_lable = $collapse_lable_text;
			} else {
				$collapse_lable = __('+ expand source', 'wp_sh');
			}
		} elseif ($wp_sh_lib_ver == "2.1") {
			if ($collapse_lable_text != "") {
				$collapse_lable = $collapse_lable_text;
			} else {
				$collapse_lable = __('show source', 'wp_sh');
			}
		}
		// Write out
		echo "\n<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." Begin -->\n";
		echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shCore.js?ver=".$wp_sh_lib_ver."\"></script>\n";
		if ($legacy_enable == 1) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shLegacy.js?ver=".$wp_sh_lib_ver."\"></script>\n";
		}
		$wp_sh_brush_files = get_option('wp_sh_brush_files');
		if ($wp_sh_lib_ver == "3.0" && $legacy_enable == 0) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shAutoloader.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			if ($wp_sh_brush_files[XML][3] == "true" || is_admin()) {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			}
		} elseif ($wp_sh_lib_ver == "3.0" && $legacy_enable == 1) {
			echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shAutoloader.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			foreach ($wp_sh_brush_files as $lang => $val) {
				$brush_file = $val[0];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if (($brush_ver == '3.0' || $brush_ver == '2.1' || $brush_ver == '1.5') && $brush_enable == 'true') {
					echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$wp_sh_lib_ver."\"></script>\n";
				} elseif (($brush_ver == '3.0' || $brush_ver == 'all') && $brush_enable == 'added') {
					echo "<script type=\"text/javascript\" src=\"".$brush_file."?ver=".$wp_sh_lib_ver."\"></script>\n";
				}
			}
			if (is_admin() && $wp_sh_brush_files[XML][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			}
		} elseif ($wp_sh_lib_ver == "2.1") {
			$wp_sh_brush_files = get_option('wp_sh_brush_files');
			foreach ($wp_sh_brush_files as $lang => $val) {
				$brush_file = $val[0];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if (($brush_ver == '2.1' || $brush_ver == '1.5') && $brush_enable == 'true') {
					echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$wp_sh_lib_ver."\"></script>\n";
				} elseif (($brush_ver == '2.1' || $brush_ver == 'all') && $brush_enable == 'added') {
					echo "<script type=\"text/javascript\" src=\"".$brush_file."?ver=".$wp_sh_lib_ver."\"></script>\n";
				}
			}
			if (is_admin() && $wp_sh_brush_files[PHP][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushPhp.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			}
			if (is_admin() && $wp_sh_brush_files[XML][3] == "false") {
				echo "<script type=\"text/javascript\" src=\"".$wp_sh_plugin_url.$lib_dir."/scripts/shBrushXml.js?ver=".$wp_sh_lib_ver."\"></script>\n";
			}
			do_action('wpsh_brush_for_2'); // Action hook for developers
		}
		if ($wp_sh_lib_ver == "3.0") {
			echo "<script type=\"text/javascript\">//<![CDATA[
	SyntaxHighlighter.autoloader(\n";
			$wp_sh_brush_files = get_option('wp_sh_brush_files');
			$count = 0;
			foreach ($wp_sh_brush_files as $lang => $val) {
				$brush_file = $val[0];
				$brush_alias = $val[1];
				$brush_ver = $val[2];
				$brush_enable = $val[3];
				if ($brush_enable == 'true' || (is_admin() && $lang == "PHP")) {
					$count = $count + 1;
					if ($count == 1) {
						echo "	\"".$brush_alias."	".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$wp_sh_lib_ver."\"\n";
					} else {
						echo "	,\"".$brush_alias."	".$wp_sh_plugin_url.$lib_dir."/scripts/".$brush_file."?ver=".$wp_sh_lib_ver."\"\n";
					}
				} elseif (($brush_ver == '3.0' || $brush_ver == 'all') && $brush_enable == 'added') {
					$count = $count + 1;
					if ($count == 1) {
						echo "	\"".$brush_alias."	".$brush_file."?ver=".$wp_sh_lib_ver."\"\n";
					} else {
						echo "	,\"".$brush_alias."	".$brush_file."?ver=".$wp_sh_lib_ver."\"\n";
					}
				}
			}
			do_action('wpsh_brush_for_3'); // Action hook for developers
			echo "	);
	SyntaxHighlighter.defaults['auto-links'] = ".$auto_links.";
	SyntaxHighlighter.defaults['title'] = '".$title."';
	SyntaxHighlighter.defaults['class-name'] = '".$class_name."';
	SyntaxHighlighter.defaults['collapse'] = ".$collapse.";
	SyntaxHighlighter.defaults['first-line'] = ".$first_line.";
	SyntaxHighlighter.defaults['gutter'] = ".$gutter.";
	SyntaxHighlighter.defaults['pad-line-numbers'] = ".$padding_line.";
	SyntaxHighlighter.defaults['smart-tabs'] = ".$smart_tabs.";
	SyntaxHighlighter.defaults['tab-size'] = ".$tab_size.";
	SyntaxHighlighter.defaults['toolbar'] = ".$toolbar.";\n";
			if ($legacy_enable == 1) {
				echo " SyntaxHighlighter.config.stripBrs = true;\n";
			}
			echo " SyntaxHighlighter.config.strings.expandSource = '".$collapse_lable."';
	SyntaxHighlighter.config.strings.help = '".__( '?', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.alert = '".__( 'SyntaxHighlighter\n\n', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.noBrush = \"".__( 'Can\'t find brush for: ', 'wp_sh' )."\";
	SyntaxHighlighter.config.strings.brushNotHtmlScript = \"".__( 'Brush wasn\'t configured for html-script option: ', 'wp_sh' )."\";
	SyntaxHighlighter.all();
	".$legacy."
//]]></script>
<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." End -->\n";
		} elseif ($wp_sh_lib_ver == "2.1") {
			echo "<script type=\"text/javascript\">//<![CDATA[
	SyntaxHighlighter.config.clipboardSwf = '".$wp_sh_plugin_url.$lib_dir."/scripts/clipboard.swf';
	SyntaxHighlighter.defaults['auto-links'] = ".$auto_links.";
	SyntaxHighlighter.defaults['class-name'] = '".$class_name."';
	SyntaxHighlighter.defaults['collapse'] = ".$collapse.";
	SyntaxHighlighter.defaults['first-line'] = ".$first_line.";
	SyntaxHighlighter.defaults['gutter'] = ".$gutter.";
	SyntaxHighlighter.defaults['pad-line-numbers'] = ".$padding_line.";
	SyntaxHighlighter.defaults['smart-tabs'] = ".$smart_tabs.";
	SyntaxHighlighter.defaults['tab-size'] = ".$tab_size.";
	SyntaxHighlighter.defaults['toolbar'] = ".$toolbar.";
	SyntaxHighlighter.defaults['wrap-lines'] = ".$wrap.";\n";
			if ($legacy_enable == 1) {
				echo " SyntaxHighlighter.config.stripBrs = true;\n";
			}
			echo " SyntaxHighlighter.config.strings.expandSource = '".$collapse_lable."';
	SyntaxHighlighter.config.strings.viewSource = '".__( 'view source', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.copyToClipboard = '".__( 'copy to clipboard', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.copyToClipboardConfirmation = '".__( 'The code is in your clipboard now', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.print = '".__( 'print', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.help = '".__( '?', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.alert = '".__( 'SyntaxHighlighter\n\n', 'wp_sh' )."';
	SyntaxHighlighter.config.strings.noBrush = \"".__( 'Can\'t find brush for: ', 'wp_sh' )."\";
	SyntaxHighlighter.config.strings.brushNotHtmlScript = \"".__( 'Brush wasn\'t configured for html-script option: ', 'wp_sh' )."\";
	SyntaxHighlighter.all();
	".$legacy."
//]]></script>
<!-- WP SyntaxHighlighter Ver.".$wp_sh_ver." End -->\n";
		}
	} else {
		echo '';
	}
}

// Validate css format
function wp_sh_valid_css($css) {
	if (preg_match("/(http|https):\/\/.*?\.js/is", $css) ||
	preg_match("/src=['\"][^(http)(https)][^'\"]*?['\"]/is", $css) ||
	preg_match("/((java|vb)script:|about:)/is", $css) ||
	preg_match("/@i[^;]*?;/is", $css) ||
	preg_match("/(expression|behavi(o|ou)r|-moz-binding|include-source)/is", $css) ||
	preg_match("/document\.cookie/i", $css) ||
	preg_match("/eval\([^\)]*?\)/i", $css) ||
	preg_match("/on.{4,}?=/is", $css) ||
	preg_match("/&\{[^\}]*?\}/i", $css) ||
	preg_match("/\xhh/i", $css) ||
	preg_match("/\\\\[^'\"\{\};:\(\)#A\*]/i", $css)) {
		return "invalid";
	} else {
		$css = preg_replace("|\*/([^ ].?)|", "*/  $1", $css);
		return $css;
	}
}

// Validate free style text data
function wp_sh_valid_text($text, $level) {
	global $allowedposttags, $allowedtags;
	if ($level == "0") {
		return $text;
	} elseif ($level == "1") {
		if (preg_match("/<meta[^>]*?>/is", $text) ||
		preg_match("/<title[^>]*?>/is", $text) ||
		preg_match("/<plaintext[^>]*?>/is", $text) ||
		preg_match("/<marquee[^>]*?>/is", $text) ||
		preg_match("/<isindex[^>]*?>/is", $text) ||
		preg_match("/<xmp[^>]*?>/is", $text) ||
		preg_match("/<listing[^>]*?>/is", $text)) {
			return "invalid";
		} else {
			return $text;
		}
	} elseif ($level == "2") {
		if (preg_match("/<script[^>]*?>/is", $text) ||
		preg_match("/<input[^>]*?>/is", $text) ||
		preg_match("/<textarea[^>]*?>/is", $text) ||
		preg_match("/<\/textarea>/is", $text) ||
		preg_match("/<object[^>]*?>/is", $text) ||
		preg_match("/<applet[^>]*?>/is", $text) ||
		preg_match("/<embed[^>]*?>/i", $text) ||
		preg_match("/<table[^>]*?>/is", $text) ||
		preg_match("/<form[^>]*?>/is", $text) ||
		preg_match("/<meta[^>]*?>/is", $text) ||
		preg_match("/<title[^>]*?>/is", $text) ||
		preg_match("/<frame[^>]*?>/is", $text) ||
		preg_match("/<plaintext[^>]*?>/is", $text) ||
		preg_match("/<marquee[^>]*?>/is", $text) ||
		preg_match("/<isindex[^>]*?>/is", $text) ||
		preg_match("/<xmp[^>]*?>/is", $text) ||
		preg_match("/<listing[^>]*?>/is", $text) ||
		preg_match("/<body[^>]*?>/is", $text) ||
		preg_match("/<style[^>]*?>/is", $text) ||
		preg_match("/<link[^>]*?>/is", $text) ||
		preg_match("/on.{4,}?=/is", $text) ||
		preg_match("/background[^=]*?=/is", $text) ||
		preg_match("/(http|https):\/\/.*?\.js/is", $text)) {
			return "invalid";
		} else {
			return $text;
		}
	} elseif ($level == "3") {
		$filtered_text = wp_kses($text, $allowedposttags);
		if ($text != $filtered_text) {
			return "invalid";
		} else {
			return $filtered_text;
		}
	} elseif ($level == "4") {
		$filtered_text = wp_kses($text, $allowedtags);
		if ($text != $filtered_text) {
			return "invalid";
		} else {
			return $filtered_text;
		}
	} elseif ($level == "5") {
		$text = esc_html($text);
		return $text;
	} else {
		return $text;
	}
}

// Resotre updated settings in DB
function wp_sh_update_setting() {
	global $wp_sh_allowed_str, $wp_sh_setting_opt;
	$wp_sh_brushes = get_option('wp_sh_brush_files');
	// Get updated settings
	$wp_sh_code_title = stripslashes($_POST['wp_sh_code_title']);
	$wp_sh_class_name = stripslashes($_POST['wp_sh_class_name']);
	$wp_sh_addl_style = stripslashes($_POST['wp_sh_addl_style']);
	$wp_sh_collapse_lable_text = stripslashes($_POST['wp_sh_collapse_lable_text']);
	$wp_sh_comment_hl_description_before = stripslashes($_POST['wp_sh_comment_hl_description_before']);
	$wp_sh_comment_hl_stylesheet = stripslashes($_POST['wp_sh_comment_hl_stylesheet']);
	// Transforming before validation
	$wp_sh_addl_style = strip_tags($wp_sh_addl_style);
	$wp_sh_comment_hl_description_before = str_replace(array("\r\n", "\r", "\n"), "<br />", $wp_sh_comment_hl_description_before);
	$wp_sh_comment_hl_stylesheet = strip_tags($wp_sh_comment_hl_stylesheet);
	// Validate values
	if (!preg_match("/^[0-9]+$/", $wp_sh_setting_opt['first_line'])) {
		wp_die(__("Invalid value. Settings could not be saved.<br />Your \"Line number(Gutter)\" must be entered in numbers.", 'wp_sh'));
	}
	if (!preg_match("/^[0-9]+$/", $wp_sh_setting_opt['tab_size'])) {
		wp_die(__("Invalid value. Settings could not be saved.<br />Your \"Tab size\" must be entered in numbers.", 'wp_sh'));
	}	
	if (strpos($wp_sh_class_name, "\"") || strpos($wp_sh_class_name, "'")) {
		wp_die(__("Invalid value. Settings could not be saved.<br />Your \"Class attribute\" contains \" or ' that are not allowed to use.", 'wp_sh'));
	}
	if (wp_sh_valid_css($wp_sh_addl_style) == "invalid") {
		wp_die(__('Invalid value. Settings could not be saved.<br />Your "Stylesheet" contains some character strings that are not allowed to use.', 'wp_sh'));
	} else {
		$wp_sh_addl_style = wp_sh_valid_css($wp_sh_addl_style);
	}
	if (wp_sh_valid_text($wp_sh_comment_hl_description_before, $wp_sh_allowed_str) == "invalid") {
		wp_die(__('Invalid value. Settings could not be saved.<br />Your "Description" for "Comment Highlighter Button" contains some character strings that are not allowed to use.', 'ez_zenback'));
	} else {
		$wp_sh_comment_hl_description_before = wp_sh_valid_text($wp_sh_comment_hl_description_before, $wp_sh_allowed_str);
	}
	if (wp_sh_valid_css($wp_sh_comment_hl_stylesheet) == "invalid") {
		wp_die(__('Invalid value. Settings could not be saved.<br />Your "Stylesheet" for "Comment Highlighter Button" contains some character strings that are not allowed to use.', 'wp_sh'));
	} else {
		$wp_sh_comment_hl_stylesheet = wp_sh_valid_css($wp_sh_comment_hl_stylesheet);
	}
	// For backward compatibility
	$wp_sh_version = $_POST['lib_version'];
	if ($_POST['gutter'] == "true") {
		$wp_sh_gutter = 1;
	} else {
		$wp_sh_gutter = 0;
	}
	$wp_sh_first_line = $_POST['first_line'];
	// Update languages
	foreach ($wp_sh_brushes as $lang => $val) {
		$brush_file = $val[0];
		$brush_alias = $val[1];
		$brush_ver = $val[2];
		$wp_sh_brush_files[$lang] = array($brush_file, $brush_alias, $brush_ver, $_POST[$lang]);
	}
	// Restore in DB
	update_option('wp_sh_version', $wp_sh_version); // For backward compatibility
	update_option('wp_sh_gutter', $wp_sh_gutter); // For backward compatibility
	update_option('wp_sh_first_line', $wp_sh_first_line); // For backward compatibility
	update_option('wp_sh_setting_opt', $wp_sh_setting_opt);
	update_option('wp_sh_code_title', $wp_sh_code_title);
	update_option('wp_sh_class_name', $wp_sh_class_name);
	update_option('wp_sh_addl_style', $wp_sh_addl_style);
	update_option('wp_sh_collapse_lable_text', $wp_sh_collapse_lable_text);
	update_option('wp_sh_comment_hl_description_before', $wp_sh_comment_hl_description_before);
	update_option('wp_sh_comment_hl_stylesheet', $wp_sh_comment_hl_stylesheet);
	update_option('wp_sh_brush_files', $wp_sh_brush_files);
	update_option('wp_sh_updated', 'false');
	// Rebuild language list
	wp_sh_rebuild_lang_list();
	// Message for admin
	echo "<div id='setting-error-settings_updated' class='updated fade'><p><strong>".__("Settings saved.","wp_sh")."</strong></p></div>";
}

// Rebuild language list
function wp_sh_rebuild_lang_list() {
	$wp_sh_language3 = get_option('wp_sh_language3');
	$wp_sh_language2 = get_option('wp_sh_language2');
	$wp_sh_brush_files = get_option('wp_sh_brush_files');
	foreach ($wp_sh_language3 as $alias3 => $val3) {
		$lang_label = $val3[0];
		$lang_enable = $val3[1];
		$pattern1 = '/^'.$alias3.'$/i';
		$pattern2 = '/^'.$alias3.'\s/i';
		$pattern3 = '/\s'.$alias3.'\s/i';
		$pattern4 = '/\s'.$alias3.'$/i';
		if ($lang_enable == 'added') {
			$wp_sh_language3[$alias3] = array($lang_label, $lang_enable);
		}
		foreach ($wp_sh_brush_files as $lang3 => $value3) {
			$brush_alias = $value3[1];
			$brush_enable = $value3[3];
			if (preg_match($pattern1, $brush_alias) || preg_match($pattern2, $brush_alias) || preg_match($pattern3, $brush_alias) || preg_match($pattern4, $brush_alias)) {
				$wp_sh_language3[$alias3] = array($lang_label, $brush_enable);
			}
		}
	}
	foreach ($wp_sh_language2 as $alias2 => $val2) {
		$lang_label = $val2[0];
		$lang_enable = $val2[1];
		$pattern1 = '/^'.$alias2.'$/i';
		$pattern2 = '/^'.$alias2.'\s/i';
		$pattern3 = '/\s'.$alias2.'\s/i';
		$pattern4 = '/\s'.$alias2.'$/i';
		if ($lang_enable == 'added') {
			$wp_sh_language2[$alias2] = array($lang_label, $lang_enable);
		}
		foreach ($wp_sh_brush_files as $lang2 => $value2) {
			$brush_alias = $value2[1];
			$brush_enable = $value2[3];
			if (preg_match($pattern1, $brush_alias) || preg_match($pattern2, $brush_alias) || preg_match($pattern3, $brush_alias) || preg_match($pattern4, $brush_alias)) {
				$wp_sh_language2[$alias2] = array($lang_label, $brush_enable);
			}
		}
	}
	update_option('wp_sh_language3', $wp_sh_language3);
	update_option('wp_sh_language2', $wp_sh_language2);
}

// Reset all settings to default
function wp_sh_reset_setting() {
	global $wp_sh_db_ver;
	// Remove all settings from DB
	include_once('uninstall.php');
	// Register default settings
	wp_sh_language_array();
	wp_sh_setting_array();
	add_option('wp_sh_checkver_stamp', $wp_sh_db_ver);
	// Message for admin
	echo "<div id='setting-error-settings_updated' class='updated fade'><p><strong>".__("All settings were reset. Please <a href=\"options-general.php?page=wp-syntaxhighlighter-options\">reload the page</a>.","wp_sh")."</strong></p></div>";
}

// Setting panel
function wp_sh_options_panel() {
	global $wp_sh_plugin_url, $wp_sh_allowed_str, $wp_sh_setting_opt;
	if(!function_exists('current_user_can') || !current_user_can('manage_options')){
			die(__('Cheatin&#8217; uh?'));
	}

	// Show info on footer
	add_action('in_admin_footer', 'wp_sh_add_admin_footer');

	// Update settings
	if (isset($_POST['WP_SH_Setting_submit']) && $_POST['wp_sh_hidden_value'] == "true" && check_admin_referer("wp-sh-update_options", "_wpnonce_update_options")) {
		wp_sh_update_setting();
	}
	// Reset all settings
	if (isset($_POST['WP_SH_Reset']) && $_POST['wp_sh_reset'] == "true" && check_admin_referer("wp-sh-reset_options", "_wpnonce_reset_options")) {
		wp_sh_reset_setting();
	}

	// Load script for admin footer
	add_action('admin_footer', 'wp_sh_load_scripts_on_footer');

	?>
	<div class="wrap">
	<?php screen_icon(); ?>
	<h2>WP SyntaxHighlighter</h2>
	<h3><?php _e("1. Basic Settings", 'wp_sh') ?></h3>
	<form method="post" action="">
	<input type="hidden" name="wp_sh_hidden_value" value="true" />
	<?php wp_nonce_field("wp-sh-update_options", "_wpnonce_update_options"); ?>
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><?php _e('Higlight your code in', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="highlight_home" value="1" <?php if ($wp_sh_setting_opt['highlight_home'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Home', 'wp_sh') ?> <input type="checkbox" name="highlight_posts" value="1" <?php if ($wp_sh_setting_opt['highlight_posts'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Posts & Pages', 'wp_sh') ?> <input type="checkbox" name="highlight_categories" value="1" <?php if ($wp_sh_setting_opt['highlight_categories'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Categories', 'wp_sh') ?> <input type="checkbox" name="highlight_archives" value="1" <?php if ($wp_sh_setting_opt['highlight_archives'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Archives', 'wp_sh') ?> <input type="checkbox" name="highlight_search" value="1" <?php if ($wp_sh_setting_opt['highlight_search'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Search result', 'wp_sh') ?> <input type="checkbox" name="highlight_comment" value="1" <?php if ($wp_sh_setting_opt['highlight_comment'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Comments', 'wp_sh') ?> <input type="checkbox" name="highlight_others" value="1" <?php if ($wp_sh_setting_opt['highlight_others'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Others', 'wp_sh') ?>
					<p><small><?php _e("Highlighting your code in the 'Categories', 'Archives' or 'Search result' depends on your using theme.<br />Sometimes you may only have to enable 'Home' and 'Posts & Pages'.<br />Note: To enable 'Comments' means you allow visitors to post their source code as comments.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Widget', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="highlight_widgets" value="1" <?php if ($wp_sh_setting_opt['highlight_widgets'] == '1') {echo 'checked=\"checked\"';} ?>/><?php _e('Use WP SyntaxHighlighter Widget', 'wp_sh') ?>
					<p><small><?php _e("'WP SyntaxHighlighter Widget' is the widget to show highlighted code.<br />Go to 'Widgets' section under 'Appearance' menu to add the 'WP SyntaxHighlighter Widget' in your sidebar.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Library version', 'wp_sh') ?></th> 
				<td>
					<select name="lib_version">
						<option value="3.0" <?php if ($wp_sh_setting_opt['lib_version'] == "3.0") {echo 'selected="selected"';} ?>>3.0.83</option>
						<option value="2.1" <?php if ($wp_sh_setting_opt['lib_version'] == "2.1") {echo 'selected="selected"';} ?>>2.1.382</option>
					</select>
					<p><small><?php _e("Choose 'Syntax Highlighter' JavaScript library version.<br />In ver. 2.1, 'autoloader' will be disabled and <a href=\"#loaded_languages\">pre-selected language definition files</a> will be loaded at once.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Theme', 'wp_sh') ?></th> 
				<td>
					<select name="theme">
						<option value="Default" <?php if ($wp_sh_setting_opt['theme'] == "Default") {echo 'selected="selected"';} ?>>Default</option>
						<option value="Django" <?php if ($wp_sh_setting_opt['theme'] == "Django") {echo 'selected="selected"';} ?>>Django</option>
						<option value="Eclipse" <?php if ($wp_sh_setting_opt['theme'] == "Eclipse") {echo 'selected="selected"';} ?>>Eclipse</option>
						<option value="Emacs" <?php if ($wp_sh_setting_opt['theme'] == "Emacs") {echo 'selected="selected"';} ?>>Emacs</option>
						<option value="FadeToGrey" <?php if ($wp_sh_setting_opt['theme'] == "FadeToGrey") {echo 'selected="selected"';} ?>>FadeToGrey</option>
						<option value="MDUltra" <?php if ($wp_sh_setting_opt['theme'] == "MDUltra") {echo 'selected="selected"';} ?>>MDUltra</option>
						<option value="Midnight" <?php if ($wp_sh_setting_opt['theme'] == "Midnight") {echo 'selected="selected"';} ?>>Midnight</option>
						<option value="RDark" <?php if ($wp_sh_setting_opt['theme'] == "RDark") {echo 'selected="selected"';} ?>>RDark</option>
						<option value="None" <?php if ($wp_sh_setting_opt['theme'] == "None") {echo 'selected="selected"';} ?>><?php _e('None', 'wp_sh') ?></option>
						<option value="Randam" <?php if ($wp_sh_setting_opt['theme'] == "Randam") {echo 'selected="selected"';} ?>><?php _e('Randam', 'wp_sh') ?></option>
					</select>
					<p><small><?php _e("Themes for the highlighted elements. 'MDUltra' is not available for ver. 2.1.<br />If you choose 'MDUltra' in ver. 2.1, Theme will be replaced with 'Defaut' theme.<br />When 'Random' is selected, this plugin will apply different theme on each page.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Auto links', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="auto_links" value="true" <?php if($wp_sh_setting_opt['auto_links'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e('URL in the highlighted element will be linked by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Title', 'wp_sh') ?></th>
				<td>
					<input type="text" name="wp_sh_code_title" size="80" value="<?php echo esc_html(get_option('wp_sh_code_title')); ?>" />
					<p><small><?php _e('Only for ver. 3.0. This option will allow you to place Title above each code blocks or in each collapsed code blocks.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Class attribute', 'wp_sh') ?></th>
				<td>
					<input type="text" name="wp_sh_class_name" value="<?php echo esc_attr(get_option('wp_sh_class_name')); ?>" />
					<p><small><?php _e('Enter space-separated class attribute values for code block. You can use them with addtional stylesheet.<br />TIP: To enter "notranslate" will stop translating your code with "Google Translate".', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Stylesheet', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="addl_style_enable" value="1" <?php if($wp_sh_setting_opt['addl_style_enable'] == 1){echo 'checked="checked" ';} ?>/> <?php _e('Use additional CSS', 'wp_sh') ?><br />
					<textarea name="wp_sh_addl_style"  rows="8" style="width:500px"><?php echo esc_html(wp_sh_valid_css(strip_tags(get_option('wp_sh_addl_style')))); ?></textarea>
					<p><small><?php _e("Define additional CSS for code block. The defined CSS will be inserted into <code>&lt;head&gt;</code> section.<br />You can also use the class attribute defined by 'Class attribute' option.", 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Collapse', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="collapse" value="true" <?php if($wp_sh_setting_opt['collapse'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e("The code box will be collapsed by default. If you want to use this option, 'Toolbar' option must be enabled.<br />After this option is enabled, 'Toolbar' option will be enabled automatically.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Label for collapsed code block', 'wp_sh') ?></th>
				<td>
					<input type="text" name="wp_sh_collapse_lable_text" size="80" value="<?php echo esc_html(get_option('wp_sh_collapse_lable_text')); ?>" />
					<p><small><?php _e("Enter text label for collapsed code block. If you use this option in ver. 3.0, 'Title' must be empty.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Line number(Gutter)', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="gutter" value="true" <?php if($wp_sh_setting_opt['gutter'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e('Line number(Gutter) will be shown by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Starting line number', 'wp_sh') ?></th>
				<td>
					<input type="text" name="first_line" size="2" value="<?php echo $wp_sh_setting_opt['first_line']; ?>" />
					<p><small><?php _e('Enter starting line number for the line numbering(Gutter).', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Line Number Padding', 'wp_sh') ?></th> 
				<td>
					<select name="padding_line">
						<option value="false" <?php if ($wp_sh_setting_opt['padding_line'] == "false") {echo 'selected="selected"';} ?>><?php _e('None', 'wp_sh') ?></option>
						<option value="true" <?php if ($wp_sh_setting_opt['padding_line'] == "true") {echo 'selected="selected"';} ?>><?php _e('Auto', 'wp_sh') ?></option>
						<option value="1" <?php if ($wp_sh_setting_opt['padding_line'] == "1") {echo 'selected="selected"';} ?>>1</option>
						<option value="2" <?php if ($wp_sh_setting_opt['padding_line'] == "2") {echo 'selected="selected"';} ?>>2</option>
						<option value="3" <?php if ($wp_sh_setting_opt['padding_line'] == "3") {echo 'selected="selected"';} ?>>3</option>
						<option value="4" <?php if ($wp_sh_setting_opt['padding_line'] == "4") {echo 'selected="selected"';} ?>>4</option>
						<option value="5" <?php if ($wp_sh_setting_opt['padding_line'] == "5") {echo 'selected="selected"';} ?>>5</option>
					</select>
					<p><small><?php _e("This option will allow you to pad line numbers with leading zeros.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Smart tabs', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="smart_tabs" value="true" <?php if($wp_sh_setting_opt['smart_tabs'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e("Indent by 'tab' will be optimized by default.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Tab size', 'wp_sh') ?></th>
				<td>
					<input type="text" name="tab_size" size="2" value="<?php echo $wp_sh_setting_opt['tab_size']; ?>" />
					<p><small><?php _e("Tab size for 'Smart tabs' feature.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Toolbar', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="toolbar" value="true" <?php if($wp_sh_setting_opt['toolbar'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e('Toolbar will be shown by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Wrap lines', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="wrap" value="true" <?php if($wp_sh_setting_opt['wrap'] == "true"){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e('Only for ver. 2.1. Long lines will be wrapped automatically by default.', 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Legacy mode', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="legacy" value="1" <?php if($wp_sh_setting_opt['legacy'] == 1){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e("Support <a href=\"http://code.google.com/p/syntaxhighlighter/wiki/Usage\">old style 'pre' tag</a> in SyntaxHighlighter ver. 1.5(Not mean WP SyntaxHighlighter ver. 1.5).<br />After this option is enabled, <a href=\"#loaded_languages\">pre-selected brush files</a> will be loaded at once.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('CSS for <code>&lt;pre&gt;</code> tag', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="css" value="1" <?php if($wp_sh_setting_opt['css'] == 1){echo 'checked="checked" ';} ?>/>
					<p><small><?php _e("If it is some time before your code highlighted, Unbeautiful code block will appear for a while.<br />This CSS will define its visual layout. Your code block may look some more good.", "wp_sh") ?></small></p>
				</td>
			</tr>
		</table>
	<h3><a href="javascript:showhide('id1');" name="tinymce_button_settings"><?php _e("2. TinyMCE Button Settings", 'wp_sh') ?></a></h3>
	<div id="id1" style="display:none;">
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><?php _e('Add TinyMCE Button', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="select_insert" value="1" <?php if($wp_sh_setting_opt['select_insert'] == 1){echo 'checked="checked" ';} ?>/> Select &amp; Insert <input type="checkbox" name="codebox" value="1" <?php if($wp_sh_setting_opt['codebox'] == 1){echo 'checked="checked" ';} ?>/> Codebox
					<p><small><?php _e("Enable/Disable TinyMCE Buttons. They can help you to type <code>&lt;pre&gt;</code> tag in 'Visual Editor'.<br />'Select &amp; Insert' will help you to wrap your code on the post or page in <code>&lt;pre&gt;</code> tag or to update values of previously-markuped code.<br />'CodeBox' will allow you to paste your code into the post or page and wrap in <code>&lt;pre&gt;</code> tag automatically, keeping indent by tabs.<br/ >In 'Visual Editor', 'Select &amp; Insert' will appear as 'pre' icon and 'CodeBox' will appear as 'CODE' icon.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Window size', 'wp_sh') ?></th> 
				<td>
					<select name="button_window_size">
						<option value="100" <?php if ($wp_sh_setting_opt['button_window_size'] == "100") {echo 'selected="selected"';} ?>>100%</option>
						<option value="105" <?php if ($wp_sh_setting_opt['button_window_size'] == "105") {echo 'selected="selected"';} ?>>105%</option>
						<option value="110" <?php if ($wp_sh_setting_opt['button_window_size'] == "110") {echo 'selected="selected"';} ?>>110%</option>
					</select>
					<p><small><?php _e("Choose size of pop-up window at the click of buttons.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Place the buttons in', 'wp_sh') ?></th> 
				<td>
					<select name="button_row">
						<option value="1" <?php if ($wp_sh_setting_opt['button_row'] == "1") {echo 'selected="selected"';} ?>><?php _e("1st row", "wp_sh") ?></option>
						<option value="2" <?php if ($wp_sh_setting_opt['button_row'] == "2") {echo 'selected="selected"';} ?>><?php _e("2nd row", "wp_sh") ?></option>
						<option value="3" <?php if ($wp_sh_setting_opt['button_row'] == "3") {echo 'selected="selected"';} ?>><?php _e("3rd row", "wp_sh") ?></option>
						<option value="4" <?php if ($wp_sh_setting_opt['button_row'] == "4") {echo 'selected="selected"';} ?>><?php _e("4th row", "wp_sh") ?></option>
					</select> <?php _e("of TinyMCE toolbar.", "wp_sh") ?>
					<p><small><?php _e("Choose TinyMCE toolbar row which buttons will be placed in.", "wp_sh") ?></small></p>
				</td>
			</tr>
		</table>
	</div>
	<h3><a href="javascript:showhide('id2');" name="quicktag_settings"><?php _e("3. Quicktag Button Settings", 'wp_sh') ?></a></h3>
	<div id="id2" style="display:none;">
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><?php _e('Add Quicktag Button', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="quicktag" value="1" <?php if($wp_sh_setting_opt['quicktag'] == 1){echo 'checked="checked" ';} ?>/><br />
					<p><small><?php _e("Enable/Disable Quicktag, 'SH pre' button. It can help you to type <code>&lt;pre&gt;</code> tag in 'HTML Editor'.<br />'SH pre' button makes easy to escape your code to HTML entities and wrap it in <code>&lt;pre&gt;</code> tag.", 'wp_sh') ?></small></p>
				</td>
			</tr>
		</table>
	</div>
	<h3><a href="javascript:showhide('id3');" name="comment_highlight"><?php _e("4. Comment Highlighter Button Settings", 'wp_sh') ?></a></h3>
	<div id="id3" style="display:none;">
		<table class="form-table">
		<?php if (version_compare(get_bloginfo('version'), "3.0", ">=")) { ?>
			<tr valign="top">
				<th scope="row"><?php _e('Add Comment HL Button', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="comment_hl_bt_enable" value="1" <?php if($wp_sh_setting_opt['comment_hl_bt_enable'] == 1){echo 'checked="checked" ';} ?>/><br />
					<p><small><?php _e("'Comment Highlighter buttons' helps visitors to post a comment with their sourcecodes and highlight them.<br />Visitors can wrap their sourcecode in &lt;pre&gt; tag easily.<br />Before you use 'Comment Highlighter buttons', you must enable 'comments' in 'Higlight your code in' option.<br />After this option is enabled, 'comments' will be enabled automatically.", 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Description', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="comment_hl_description_before_enable" value="1" <?php if($wp_sh_setting_opt['comment_hl_description_before_enable'] == 1){echo 'checked="checked" ';} ?>/> <?php _e('Add description', 'wp_sh') ?><br />
					<textarea name="wp_sh_comment_hl_description_before" rows="8" style="width:500px"><?php echo esc_html(wp_sh_valid_text(get_option('wp_sh_comment_hl_description_before'), $wp_sh_allowed_str)); ?></textarea>
					<p><small><?php _e("Enter description that is shown before the comment form.", 'wp_sh') ?></small></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e('Stylesheet', 'wp_sh') ?></th>
				<td>
					<input type="checkbox" name="comment_hl_stylesheet_enable" value="1" <?php if($wp_sh_setting_opt['comment_hl_stylesheet_enable'] == 1){echo 'checked="checked" ';} ?>/> <?php _e('Use additional CSS', 'wp_sh') ?><br />
					<textarea name="wp_sh_comment_hl_stylesheet" rows="8" style="width:500px"><?php echo esc_html(wp_sh_valid_css(strip_tags(get_option('wp_sh_comment_hl_stylesheet')))); ?></textarea>
					<p><small><?php _e("If it is needed, define additional stylesheet for the comment form.", 'wp_sh') ?></small></p>
				</td>
			</tr>
		<?php } else { ?>
			<tr valign="top">
				<th scope="row"></th>
				<td>
					<p><?php _e("This option is only for WordPress 3.0 or higher", 'wp_sh') ?></p>
				</td>
			</tr>
		<?php } ?>
		</table>
	</div>
	<h3><a href="javascript:showhide('id4');" name="loaded_languages"><?php _e("5. Default Languages Settings", 'wp_sh') ?></a></h3>
	<div id="id4" style="display:none;">
		<?php 
		$wp_sh_brush_files = get_option('wp_sh_brush_files');
		if (is_array($wp_sh_brush_files)) {
		ksort($wp_sh_brush_files);
		?>
		<table class="form-table">
			<tr valign="top"> 
				<th scope="row"></th>
				<td>
					<p><small><?php _e("Define pre-loaded or dynamic-autoloaded languages by default.<br />You should disable unused languages to prevent inserting unnecessary elements into your posts or pages.", "wp_sh") ?></small></p>
				</td>
			</tr>
			<?php
			foreach ($wp_sh_brush_files as $lang => $val) {
				$brush_enable = $val[3];
				if ($val[2] == "3.0") {
					$brush_ver = "3.0";
				} elseif (($brush_enable == "true" && $val[2] == "2.1") || ($brush_enable == "added" && $val[2] == "all")) {
					$brush_ver = "2.1, 3.0";
				} elseif (($brush_enable == "added" || $brush_enable == "removed") && $val[2] == "2.1") {
					$brush_ver = "2.1";
				} elseif (($brush_enable == "true" || $brush_enable == "false") && $val[2] == "2.1") {
					$brush_ver = "2.1, 3.0";
				} elseif ($val[2] == "1.5") {
					$brush_ver = "2.1, 3.0";
				}
				if ($brush_enable == 'true' || $brush_enable == 'false') {
			?>
			<tr valign="top">
				<th scope="row"><?php echo $lang.'(ver.'.$brush_ver.')'; ?></strong></th>
				<td>
				<label for="<?php echo $lang; ?>_Yes"><input type="radio" id="<?php echo $lang; ?>_Yes" name="<?php echo $lang; ?>" value="true" <?php if($brush_enable == 'true'){echo 'checked="checked"';}?> /><?php _e('Yes', 'wp_sh') ?></label>
				<label for="<?php echo $lang; ?>_No"><input type="radio" id="<?php echo $lang; ?>_No" name="<?php echo $lang; ?>" value="false" <?php if($brush_enable == 'false'){echo 'checked="checked"';}?> /><?php _e('No', 'wp_sh') ?></label>
				</td>
			</tr>
				<?php } elseif ($brush_enable == 'added' || $brush_enable == 'removed') { ?>
			<tr valign="top">
				<th scope="row"><?php echo $lang.'(ver.'.$brush_ver.')'; ?></strong></th>
				<td>
				<label for="<?php echo $lang; ?>_Added"><input type="radio" id="<?php echo $lang; ?>_Added" name="<?php echo $lang; ?>" value="added" <?php if($brush_enable == 'added'){echo 'checked="checked"';}?> /><?php _e('Yes', 'wp_sh') ?></label>
				<label for="<?php echo $lang; ?>_Removed"><input type="radio" id="<?php echo $lang; ?>_Removed" name="<?php echo $lang; ?>" value="removed" <?php if($brush_enable == 'removed'){echo 'checked="checked"';}?> /><?php _e('No', 'wp_sh') ?></label>
				</td>
			</tr>
				<?php }
			} ?>
		</table>
		<?php } ?>
	</div>
		<p class="submit">
		<input type="submit" name="WP_SH_Setting_submit" value="<?php _e('Save Changes', 'wp_sh') ?>" />
		</p>
	</form>
	<h3><?php _e("6. Restore all settings to default", 'wp_sh') ?></h3>
	<form method="post" action="" onsubmit="return confirmreset()">
		<?php wp_nonce_field("wp-sh-reset_options", "_wpnonce_reset_options"); ?>
		<input type="hidden" name="wp_sh_reset" value="true" />
		<p class="submit">
		<input type="submit" name="WP_SH_Reset" value="<?php _e('Reset All Settings', 'wp_sh') ?>" />
		</p>
	</form>
	<h3><?php _e('7. Your Current Theme', 'wp_sh') ?></h3>
	<div style="width:600px; margin-left:20px">
	<pre class="brush: php; html-script: true; highlight: 9">
	&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
	&lt;html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"&gt;
	&lt;head&gt;
		&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /&gt;
		&lt;title&gt;Syntax Highlighting Example&lt;/title&gt;
	&lt;/head&gt;
	&lt;body style="width:500px"&gt;
		&lt;h1&gt;Syntax Highlighting Example&lt;/h1&gt;
		&lt;p&gt;&lt;?php echo 'Hello World!' ?&gt;&lt;/p&gt;
		&lt;p&gt;XHTML with PHP script.&lt;/p&gt;
		&lt;div class="tabs"&gt;
  			TAB	TAB		TAB	TAB
				TAB	TAB	TAB		TAB
			TAB		TAB		TAB	TAB
		&lt;p&gt;For 'Smart tabs'.&lt;/p&gt;
		&lt;/div&gt;

		&lt;p&gt;http://wordpress.org/&lt;/p&gt;
	&lt;/body&gt;
	&lt;/html&gt;</pre>
	</div>
	<h3><a href="javascript:showhide('id5');" name="system_info"><?php _e("8. Your System Info", 'wp_sh') ?></a></h3>
	<div id="id5" style="display:none; margin-left:20px;">
	<p>
	<?php _e('Server OS:', 'wp_sh') ?> <?php echo php_uname('s').' '.php_uname('r'); ?><br />
	<?php _e('PHP version:', 'wp_sh') ?> <?php echo phpversion(); ?><br />
	<?php _e('MySQL version:', 'wp_sh') ?> <?php echo mysql_get_server_info(); ?><br />
	<?php _e('WordPress version:', 'wp_sh') ?> <?php bloginfo("version"); ?><br />
	<?php _e('Site URL:', 'wp_sh') ?> <?php bloginfo("url"); ?><br />
	<?php _e('WordPress URL:', 'wp_sh') ?> <?php bloginfo("wpurl"); ?><br />
	<?php _e('WordPress language:', 'wp_sh') ?> <?php bloginfo("language"); ?><br />
	<?php _e('WordPress character set:', 'wp_sh') ?> <?php bloginfo("charset"); ?><br />
	<?php _e('WordPress theme:', 'wp_sh') ?> <?php $wp_sh_theme = get_theme(get_current_theme()); echo $wp_sh_theme['Name'].' '.$wp_sh_theme['Version']; ?><br />
	<?php _e('WP SyntaxHighlighter version:', 'wp_sh') ?> <?php $wp_sh_plugin_data = get_plugin_data(__FILE__); echo $wp_sh_plugin_data['Version']; ?><br />
	<?php _e('WP SyntaxHighlighter DB version:', 'wp_sh') ?> <?php echo get_option('wp_sh_checkver_stamp'); ?><br />
	<?php _e('WP SyntaxHighlighter URL:', 'wp_sh') ?> <?php echo $wp_sh_plugin_url; ?><br />
	<?php _e('Your browser:', 'wp_sh') ?> <?php echo $_SERVER['HTTP_USER_AGENT']; ?>
	</p>
	</div>
	<p>
	<?php _e("To report a bug ,submit requests and feedback, ", 'wp_sh') ?><?php _e('Use <a href="http://wordpress.org/tags/wp-syntaxhighlighter?forum_id=10">Forum</a> or <a href="http://www.near-mint.com/blog/contact">Mail From</a>', 'wp_sh') ?>
	</p>
	</div>
<?php }

?>